<?php

namespace App\Controllers\Admin\Equipment\Link;

use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;

use App\Helpers\Equipment\Link\RamHelper;
use App\Services\Equipment\Link\RamService;
use App\Services\Equipment\Part\RamService as PartService;

class RamController extends LinkController
{
    protected ?PartService $_partService = null;
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->title = lang("{$this->getService()->getClassName()}.title");
        $this->class_path .= $this->getService()->getClassName();
        $this->uri_path .= strtolower($this->getService()->getClassName('/')) . '/';
        // $this->view_path .= strtolower($this->getService()->getClassName()) . DIRECTORY_SEPARATOR;

    }
    public function getService(): RamService
    {
        if (!$this->_service) {
            $this->_service = new RamService($this->request);
        }
        return $this->_service;
    }
    public function getHelper(): RamHelper
    {
        if (!$this->_helper) {
            $this->_helper = new RamHelper($this->request);
        }
        return $this->_helper;
    }
    public function getPartService(): PartService
    {
        if (!$this->_partService) {
            $this->_partService = new PartService($this->request);
        }
        return $this->_partService;
    }
    //Index,FieldForm관련
    protected function index_process(): array
    {
        $fields = [
            'fields' => ['serverinfo_uid', 'raminfo_uid'],
        ];
        $this->init('index',  $fields);
        return parent::index_process();
    }
}
